package org.wisterina.android.utility.dialogfragment.fileselect;

import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;

/**
 * t@CI_CAOtOgNXłB
 */
public class FileSelectDialogFragment extends DialogFragment implements AdapterView.OnItemClickListener {
	/**
	 * [gfBNg\܂B
	 */
	public static final String ROOT_DIRECTORY = "rootDirectory";
	/**
	 * _CAO\̃fBNg\܂B
	 */
	public static final String INITIAL_DIRECTORY = "initialDirectory";
	/**
	 * efBNg̃eLXg\܂B
	 */
	public static final String PREVIOUS = "previous";
	/**
	 * LZ{^̕\܂B
	 */
	public static final String CANCEL = "cancel";
	/**
	 * Xi\܂B
	 */
	public static final String LISTENER = "listener";
	/**
	 * ݑI𒆂̃fBNg\܂B
	 */
	private static final String DIRECTORY = "directory";
	/**
	 * A_v^[B
	 */
	private ArrayAdapter<String> adapter;
	/**
	 * t@CB
	 */
	private List<FileInformation> fileInformations = new ArrayList<FileInformation>();
	
	@Override
	public Dialog onCreateDialog(Bundle savedInstanceState) {
		Activity activity = this.getActivity();
		AlertDialog.Builder builder = new AlertDialog.Builder(activity);
		
		ListView listView = new ListView(activity);
		this.adapter = new ArrayAdapter<String>(activity, android.R.layout.simple_list_item_1);
		listView.setAdapter(this.adapter);
		
		this.initializeArguments();
		
		// r[XV
		this.updateView();
		
		listView.setOnItemClickListener(this);
		builder.setView(listView);
		
		Bundle bundle = this.getArguments();
		builder.setTitle(bundle.getString(DIRECTORY) + File.separator);
		builder.setNegativeButton(bundle.getString(CANCEL), new CancelListener());
		
		return builder.create();
	}

	@Override
	public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
		Dialog dialog = this.getDialog();
		Bundle bundle = this.getArguments();
		String directory = bundle.getString(DIRECTORY);
		
		if(position == 0) {
			// ԏIꍇ
			if(directory.length() > bundle.getString(ROOT_DIRECTORY).length()) {
				// ʏ͖߂鏈
				directory = directory.substring(0, directory.lastIndexOf(File.separator));
				bundle.putString(DIRECTORY, directory);
				
				// _CAOƃr[XV
				dialog.setTitle(directory + File.separator);
				this.updateView();
			} else {
				// gbvfBNg̏ꍇ͉Ȃ
			}
		} else {
			directory = directory + File.separator + this.fileInformations.get(position - 1).getFile().getName();
			File file = new File(directory);
			if(file.isDirectory()) {
				// fBNg̏ꍇ͂̒ֈړ
				bundle.putString(DIRECTORY, directory);
				
				// _CAOƃr[XV
				dialog.setTitle(directory + File.separator);
				this.updateView();
			} else {
				// t@Cm
				OnFileSelectedListener listener = (OnFileSelectedListener)this.getArguments().getSerializable(LISTENER);
				listener.onFileSelected(directory);
				
				// ̃_CAOI
				this.dismiss();
			}
		}
	}
	
	/**
	 * vf܂B
	 */
	private void initializeArguments() {
		Bundle bundle = this.getArguments();
		if(bundle.getString(ROOT_DIRECTORY) == null) {
			bundle.putString(ROOT_DIRECTORY, File.separator);
		}
		if(bundle.getString(INITIAL_DIRECTORY) == null) {
			bundle.putString(INITIAL_DIRECTORY, bundle.getString(ROOT_DIRECTORY));
		}
		if(bundle.getString(DIRECTORY) == null) {
			bundle.putString(DIRECTORY, bundle.getString(INITIAL_DIRECTORY));
		}
		if(bundle.getString(PREVIOUS) == null) {
			bundle.putString(PREVIOUS, "..");
		}
	}
	/**
	 * r[XV܂B
	 */
	private void updateView() {
		this.adapter.clear();
		
		Bundle bundle = this.getArguments();
		this.adapter.add(bundle.getString(PREVIOUS));
		
		String directory = bundle.getString(DIRECTORY);
		if(directory.equals("")) {
			directory = File.separator;
		}
		
		this.fileInformations.clear();
		File[] files = new File(directory).listFiles();
		
		if(files != null) {
			for(File file : files) {
				this.fileInformations.add(new FileInformation(file));
			}
			
			// \[g
			Collections.sort(this.fileInformations);
			
			for(FileInformation fileInformation : this.fileInformations) {
				File file = fileInformation.getFile();
				if(file.isDirectory()) {
					this.adapter.add(file.getName() + File.separator);
				} else {
					this.adapter.add(file.getName());
				}
			}
		}
	}
	
	/**
	 * LZ郊XiłB
	 */
	private class CancelListener implements DialogInterface.OnClickListener {

		@Override
		public void onClick(DialogInterface dialog, int which) {
			OnFileSelectedListener listener = (OnFileSelectedListener)FileSelectDialogFragment.this.getArguments().getSerializable(LISTENER);
			listener.onFileSelectCanceled();
		}
	}
}
